# image

Image v2

## image create

Create/upload an image

    openstack image create
        [--id <id>]
        [--container-format <container-format>]
        [--disk-format <disk-format>]
        [--min-disk <disk-gb>]
        [--min-ram <ram-mb>]
        [--file <file> | --volume <volume>]
        [--force]
        [--progress]
        [--sign-key-path <sign-key-path>]
        [--sign-cert-id <sign-cert-id>]
        [--protected
        |
        --unprotected
        ]
        [--public
        |
        --private
        |
        --community
        |
        --shared
        ]
        [--property <key=value>]
        [--tag <tag>]
        [--project <project>]
        [--import]
        [--project-domain <project-domain>]
        <image-name>

--id <id>

  Image ID to reserve

--container-format <container-format>

  Image container format. The supported options are: ami, ari, aki, bare, docker, ova, ovf. The default format is: bare

--disk-format <disk-format>

  Image disk format. The supported options are: ami, ari, aki, vhd, vmdk, raw, qcow2, vhdx, vdi, iso, ploop. The default format is: raw

--min-disk <disk-gb>

  Minimum disk size needed to boot image, in gigabytes

--min-ram <ram-mb>

  Minimum RAM size needed to boot image, in megabytes

--file <file>

  Upload image from local file

--volume <volume>

  Create image from a volume

--force

  Force image creation if volume is in use (only meaningful with –volume)

--progress

  Show upload progress bar (ignored if passing data via stdin)

--sign-key-path <sign-key-path>

  Sign the image using the specified private key. Only use in combination with –sign-cert-id

--sign-cert-id <sign-cert-id>

  The specified certificate UUID is a reference to the certificate in the key manager that corresponds to the public key and is used for signature validation. Only use in combination with –sign-key-path

--protected

  Prevent image from being deleted

--unprotected

  Allow image to be deleted (default)

--public

  Image is accessible and visible to all users

--private

  Image is only accessible by the owner (default until –os-image-api-version 2.5)

--community

  Image is accessible by all users but does not appear in the default image list of any user except the owner (requires –os-image-api-version 2.5 or later)

--shared

  Image is only accessible by the owner and image members (requires –os-image-api-version 2.5 or later) (default since –os-image-api-version 2.5)

--property <key=value>

  Set a property on this image (repeat option to set multiple properties)

--tag <tag>

  Set a tag on this image (repeat option to set multiple tags)

--project <project>

  Set an alternate project on this image (name or ID)

--import

  Force the use of glance image import instead of direct upload

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

image-name

  New image name

## image delete

Delete image(s)

    openstack image delete [--store <STORE>] <image> [<image> ...]

--store <STORE>

  Store to delete image(s) from.

image

  Image(s) to delete (name or ID)

## image list

List available images

    openstack image list
        [--format-config-file FORMAT_CONFIG]
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--public
        |
        --private
        |
        --community
        |
        --shared
        |
        --all
        ]
        [--property <key=value>]
        [--name <name>]
        [--status <status>]
        [--member-status <member-status>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--tag <tag>]
        [--hidden]
        [--long]
        [--sort <key>[:<direction>]]
        [--limit <limit>]
        [--marker <marker>]

--format-config-file <FORMAT_CONFIG>

  Config file for the dict-to-csv formatter

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--public

  List only public images

--private

  List only private images

--community

  List only community images (requires –os-image-api-version 2.5 or later)

--shared

  List only shared images (requires –os-image-api-version 2.5 or later)

--all

  List all images

--property <key=value>

  Filter output based on property (repeat option to filter on multiple properties)

--name <name>

  Filter images based on name.

--status <status>

  Filter images based on status.

--member-status <member-status>

  Filter images based on member status. The supported options are: accepted, pending, rejected, all.

--project <project>

  Search by project (admin only) (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--tag <tag>

  Filter images based on tag. (repeat option to filter on multiple tags)

--hidden

  List hidden images

--long

  List additional fields in output

--sort <key>[:<direction>]

  Sort output by selected keys and directions (asc or desc) (default: name:asc), multiple keys and directions can be specified separated by comma

--limit <limit>

  The maximum number of entries to return. If the value exceeds the server-defined maximum, then the maximum value will be used.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

## image save

Save an image locally

    openstack image save
        [--chunk-size <chunk-size>]
        [--file <filename>]
        <image>

--chunk-size <chunk-size>

  Size in bytes to read from the wire and buffer at one time (default: 1024)

--file <filename>

  Downloaded image save filename (default: stdout)

image

  Image to save (name or ID)

## image set

Set image properties

    openstack image set
        [--name <name>]
        [--min-disk <disk-gb>]
        [--min-ram <ram-mb>]
        [--container-format <container-format>]
        [--disk-format <disk-format>]
        [--protected
        |
        --unprotected
        ]
        [--public
        |
        --private
        |
        --community
        |
        --shared
        ]
        [--property <key=value>]
        [--tag <tag>]
        [--architecture <architecture>]
        [--instance-id <instance-id>]
        [--kernel-id <kernel-id>]
        [--os-distro <os-distro>]
        [--os-version <os-version>]
        [--ramdisk-id <ramdisk-id>]
        [--deactivate
        |
        --activate
        ]
        [--project <project>]
        [--project-domain <project-domain>]
        [--accept
        |
        --reject
        |
        --pending
        ]
        [--hidden | --unhidden]
        <image>

--name <name>

  New image name

--min-disk <disk-gb>

  Minimum disk size needed to boot image, in gigabytes

--min-ram <ram-mb>

  Minimum RAM size needed to boot image, in megabytes

--container-format <container-format>

  Image container format. The supported options are: ami, ari, aki, bare, docker, ova, ovf

--disk-format <disk-format>

  Image disk format. The supported options are: ami, ari, aki, vhd, vmdk, raw, qcow2, vhdx, vdi, iso, ploop

--protected

  Prevent image from being deleted

--unprotected

  Allow image to be deleted (default)

--public

  Image is accessible and visible to all users

--private

  Image is only accessible by the owner (default until –os-image-api-version 2.5)

--community

  Image is accessible by all users but does not appear in the default image list of any user except the owner (requires –os-image-api-version 2.5 or later)

--shared

  Image is only accessible by the owner and image members (requires –os-image-api-version 2.5 or later) (default since –os-image-api-version 2.5)

--property <key=value>

  Set a property on this image (repeat option to set multiple properties)

--tag <tag>

  Set a tag on this image (repeat option to set multiple tags)

--architecture <architecture>

  Operating system architecture

--instance-id <instance-id>

  ID of server instance used to create this image

--kernel-id <kernel-id>

  ID of kernel image used to boot this disk image

--os-distro <os-distro>

  Operating system distribution name

--os-version <os-version>

  Operating system distribution version

--ramdisk-id <ramdisk-id>

  ID of ramdisk image used to boot this disk image

--deactivate

  Deactivate the image

--activate

  Activate the image

--project <project>

  Set an alternate project on this image (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--accept

  Accept the image membership for either the project indicated by ‘–project’, if provided, or the current user’s project

--reject

  Reject the image membership for either the project indicated by ‘–project’, if provided, or the current user’s project

--pending

  Reset the image membership to ‘pending’

--hidden

  Hide the image

--unhidden

  Unhide the image

image

  Image to modify (name or ID)

## image unset

Unset image tags and properties

    openstack image unset [--tag <tag>] [--property <property-key>] <image>

--tag <tag>

  Unset a tag on this image (repeat option to unset multiple tags)

--property <property-key>

  Unset a property on this image (repeat option to unset multiple properties)

image

  Image to modify (name or ID)

## image show

Display image details

    openstack image show [--human-readable] <image>

--human-readable

  Print image size in a human-friendly format.

image

  Image to display (name or ID)

## image stage

Upload data for a specific image to staging. This requires support for the interoperable image import process, which was first introduced in Image API version 2.6 (Glance 16.0.0 (Queens))

    openstack image stage [--file <file>] [--progress] <image>

--file <file>

  Local file that contains disk image to be uploaded. Alternatively, images can be passed via stdin.

--progress

  Show upload progress bar (ignored if passing data via stdin)

image

  Image to upload data for (name or ID)

## image import

Initiate the image import process. This requires support for the interoperable image import process, which was first introduced in Image API version 2.6 (Glance 16.0.0 (Queens))

    openstack image import
        [--method <method>]
        [--uri <uri>]
        [--remote-image <REMOTE_IMAGE>]
        [--remote-region <REMOTE_GLANCE_REGION>]
        [--remote-service-interface <REMOTE_SERVICE_INTERFACE>]
        [--store [<STORE> ...]
        |
        --all-stores
        ]
        [--allow-failure | --disallow-failure]
        [--wait]
        <image>

--method <method>

  Import method used for image import process. Not all deployments will support all methods. The ‘glance-direct’ method (default) requires images be first staged using the ‘image-stage’ command.

--uri <uri>

  URI to download the external image (only valid with the ‘web-download’ import method)

--remote-image <REMOTE_IMAGE>

  The image of remote glance (ID only) to be imported (only valid with the ‘glance-download’ import method)

--remote-region <REMOTE_GLANCE_REGION>

  The remote Glance region to download the image from (only valid with the ‘glance-download’ import method)

--remote-service-interface <REMOTE_SERVICE_INTERFACE>

  The remote Glance service interface to use when importing images (only valid with the ‘glance-download’ import method)

--store <STORE>

  Backend store to upload image to (specify multiple times to upload to multiple stores) (either ‘–store’ or ‘–all-stores’ required with the ‘copy-image’ import method)

--all-stores

  Make image available to all stores (either ‘–store’ or ‘–all-stores’ required with the ‘copy-image’ import method)

--allow-failure

  When uploading to multiple stores, indicate that the import should be continue should any of the uploads fail. Only usable with –stores or –all-stores

--disallow-failure

  When uploading to multiple stores, indicate that the import should be reverted should any of the uploads fail. Only usable with –stores or –all-stores

--wait

  Wait for operation to complete

image

  Image to initiate import process for (name or ID)

this page last updated: 2026-04-01 09:44:20

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.